local M = {}

local Number = 12345678910
local C = 3.6
local check

local function ON_OFF_GM_ENGINE(ON_OFF)
local ON_OFF = ON_OFF or 0
for _, device in pairs(powertrain.getDevices()) do
	if ON_OFF == 1 and device.clutchMaxSafeTemp ~= Number then
		device.maxPhysicalAV = Number
		device.maxTorqueRating = Number
		device.maxOverTorqueDamage = Number
		device.clutchPermanentDamageTempThreshold = Number
		device.clutchCoolingCoef = 5000
		device.clutchWarningTemp = Number
		device.clutchMaxSafeTemp = Number
		device.gearDamageThreshold = Number
		device.canFlood = false
		device.thermals = require("powertrain/OFF_thermals")
		device.thermals.OFF_thermals()
	end
	if ON_OFF == 0 and device.clutchMaxSafeTemp == Number then
		obj:queueGameEngineLua('be:reloadVehicle(0)')
	end
end
end

local function ON_OFF_MORE_POWER(ON_OFF_1, AUTO)
local ON_OFF_1 = ON_OFF_1 or 0
local AUTO = AUTO or 0

for _, device in pairs(powertrain.getDevices()) do
	if ON_OFF_1 == 1 then
		device.torqueLossCoef = -0.000001
		if electrics.values.airspeed * C < 15 and device.torqueLossCoef ~= -0.000001 then
			device.torqueLossCoef = -0.000001
		end
		if AUTO == 0 then
			if electrics.values.airspeed * C > 15 and device.torqueLossCoef == -0.000001 then
				device.torqueLossCoef = -1.0
			end
			if electrics.values.airspeed * C > 50 and device.torqueLossCoef == -1.0 then
				device.torqueLossCoef = -1.25
			end
			if electrics.values.airspeed * C > 100 and device.torqueLossCoef == -1.25 then
				device.torqueLossCoef = -1.375
			end
			if electrics.values.airspeed * C > 150 and device.torqueLossCoef == -1.375 then
				device.torqueLossCoef = -1.5
			end
			if electrics.values.airspeed * C > 200 and device.torqueLossCoef == -1.5 then
				device.torqueLossCoef = -1.625
			end
			if electrics.values.airspeed * C > 250 and device.torqueLossCoef == -1.625 then
				device.torqueLossCoef = -1.75
			end
			if electrics.values.airspeed * C > 300 and device.torqueLossCoef == -1.75 then
				device.torqueLossCoef = -2.0
			end
			if electrics.values.airspeed * C < 200 and device.torqueLossCoef <= -1.625 then
				device.torqueLossCoef = -1.5
			end
		end
		if AUTO == 1 then
			if electrics.values.airspeed * C >= 15 then
				device.torqueLossCoef = math.ceil(electrics.values.airspeed * C * -0.006666 * 100) / 100
			end
		end
	end
	if device.torqueLossCoef == nil then check = 1 else
		if device.torqueLossCoef < 0 then check = 2 end
		if device.torqueLossCoef > 0 then check = 1 end
	end
	if ON_OFF_1 == 0 then
		if check == 2 then
			device.torqueLossCoef = 0.01
		end
	end
end
end

local function WTF_MODE ()
electrics.values.wheelspeed = 277777777777777.4
end

M.ON_OFF_GM_ENGINE = ON_OFF_GM_ENGINE
M.ON_OFF_MORE_POWER = ON_OFF_MORE_POWER
M.WTF_MODE = WTF_MODE
return M