local M = {}

  local COLOR_Q = 1
  local COLOR_W = 0
  local COLOR_E = 0
  local Color_Speed = 0.005
  local surfaces = {}
  local scale_1 = 1.0
  local scale_2 = 1.0

local function ColorCycler2(Roughness)
  local objID = objID or be:getPlayerVehicleID(0)
  local Roughness = Roughness or 0
  local veh = be:getObjectByID(objID)
  local vd = extensions.core_vehicle_manager.getVehicleData(objID)

  vd.config.paints = vd.config.paints or {}

  if COLOR_Q > 0.999 and COLOR_W < 1 and COLOR_E < 0.001 then COLOR_W = COLOR_W + Color_Speed else COLOR_W = COLOR_W end
  if COLOR_Q > 0 and COLOR_W > 0.999 and COLOR_E < 0.001 then COLOR_Q = COLOR_Q - Color_Speed else COLOR_Q = COLOR_Q end
  if COLOR_Q < 0.001 and COLOR_W > 0.999 and COLOR_E < 1 then COLOR_E = COLOR_E + Color_Speed else COLOR_E = COLOR_E end
  if COLOR_Q < 0.001 and COLOR_W > 0 and COLOR_E > 0.999 then COLOR_W = COLOR_W - Color_Speed else COLOR_W = COLOR_W end
  if COLOR_Q < 1 and COLOR_W < 0.001 and COLOR_E > 0.999 then COLOR_Q = COLOR_Q + Color_Speed else COLOR_Q = COLOR_Q end
  if COLOR_Q > 0.999 and COLOR_W < 0.001 and COLOR_E > 0 then COLOR_E = COLOR_E - Color_Speed else COLOR_E = COLOR_E end

  if COLOR_Q < 0 then COLOR_Q = 0 end
  if COLOR_W < 0 then COLOR_W = 0 end
  if COLOR_E < 0 then COLOR_E = 0 end

  local paint = createVehiclePaint({x=COLOR_Q, y=COLOR_W, z=COLOR_E, w=2}, {1, Roughness, 0, 0})

  vd.config.paints[1] = paint
  vd.config.paints[2] = paint
  vd.config.paints[3] = paint
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 1, paint)
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 2, paint)
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 3, paint)
end

local function Drift_Drag_WTF_Mode(Mode)
  local Mode = Mode or 0
  if Mode == 0 then scale_1 = 1.0 scale_2 = 1.0 end
  if Mode == 1 then scale_1 = 0.5 scale_2 = 0.5 end
  if Mode == 2 then scale_1 = 2.0 scale_2 = 3.5 end
  if Mode == 3 then scale_1 = 0.9 scale_2 = -0.5 end

  surfaces["ASPHALT"] = be:getGroundModel("ASPHALT").data surfaces["ASPHALT"]["staticFrictionCoefficient"] = 0.98*scale_1 surfaces["ASPHALT"]["slidingFrictionCoefficient"] = 0.7*scale_2 be:setGroundModel("ASPHALT", surfaces["ASPHALT"])
  surfaces["ASPHALT_OLD"] = be:getGroundModel("ASPHALT_OLD").data surfaces["ASPHALT_OLD"]["staticFrictionCoefficient"] = 0.96*scale_1 surfaces["ASPHALT_OLD"]["slidingFrictionCoefficient"] = 0.67*scale_2 be:setGroundModel("ASPHALT_OLD", surfaces["ASPHALT_OLD"])
  surfaces["ASPHALT_PREPPED"] = be:getGroundModel("ASPHALT_PREPPED").data surfaces["ASPHALT_PREPPED"]["staticFrictionCoefficient"] = 1.5*scale_1 surfaces["ASPHALT_PREPPED"]["slidingFrictionCoefficient"] = 1.2*scale_2 be:setGroundModel("ASPHALT_PREPPED", surfaces["ASPHALT_PREPPED"])
  surfaces["ASPHALT_WET"] = be:getGroundModel("ASPHALT_WET").data surfaces["ASPHALT_WET"]["staticFrictionCoefficient"] = 0.92*scale_1 surfaces["ASPHALT_WET"]["slidingFrictionCoefficient"] = 0.55*scale_2 be:setGroundModel("ASPHALT_WET", surfaces["ASPHALT_WET"])
  surfaces["ASPHALT_WET2"] = be:getGroundModel("ASPHALT_WET2").data surfaces["ASPHALT_WET2"]["staticFrictionCoefficient"] = 0.92*scale_1 surfaces["ASPHALT_WET2"]["slidingFrictionCoefficient"] = 0.55*scale_2 be:setGroundModel("ASPHALT_WET2", surfaces["ASPHALT_WET2"])
  surfaces["ASPHALT_WET3"] = be:getGroundModel("ASPHALT_WET3").data surfaces["ASPHALT_WET3"]["staticFrictionCoefficient"] = 0.92*scale_1 surfaces["ASPHALT_WET3"]["slidingFrictionCoefficient"] = 0.55*scale_2 be:setGroundModel("ASPHALT_WET3", surfaces["ASPHALT_WET3"])
  surfaces["CONCRETE"] = be:getGroundModel("CONCRETE").data surfaces["CONCRETE"]["staticFrictionCoefficient"] = 0.98*scale_1 surfaces["CONCRETE"]["slidingFrictionCoefficient"] = 0.7*scale_2 be:setGroundModel("CONCRETE", surfaces["CONCRETE"])
  surfaces["CONCRETE2"] = be:getGroundModel("CONCRETE2").data surfaces["CONCRETE2"]["staticFrictionCoefficient"] = 0.98*scale_1 surfaces["CONCRETE2"]["slidingFrictionCoefficient"] = 0.7*scale_2 be:setGroundModel("CONCRETE2", surfaces["CONCRETE2"])
  surfaces["GRID"] = be:getGroundModel("GRID").data surfaces["GRID"]["staticFrictionCoefficient"] = 0.98*scale_1 surfaces["GRID"]["slidingFrictionCoefficient"] = 0.7*scale_2 be:setGroundModel("GRID", surfaces["GRID"])
  surfaces["GROUNDMODEL_ASPHALT1"] = be:getGroundModel("GROUNDMODEL_ASPHALT1").data surfaces["GROUNDMODEL_ASPHALT1"]["staticFrictionCoefficient"] = 0.98*scale_1 surfaces["GROUNDMODEL_ASPHALT1"]["slidingFrictionCoefficient"] = 0.7*scale_2 be:setGroundModel("GROUNDMODEL_ASPHALT1", surfaces["GROUNDMODEL_ASPHALT1"])
  surfaces["GROUNDMODEL_ASPHALT_OLD"] = be:getGroundModel("GROUNDMODEL_ASPHALT_OLD").data surfaces["GROUNDMODEL_ASPHALT_OLD"]["staticFrictionCoefficient"] = 0.96*scale_1 surfaces["GROUNDMODEL_ASPHALT_OLD"]["slidingFrictionCoefficient"] = 0.67*scale_2 be:setGroundModel("GROUNDMODEL_ASPHALT_OLD", surfaces["GROUNDMODEL_ASPHALT_OLD"])
  surfaces["SLIPPERY"] = be:getGroundModel("SLIPPERY").data surfaces["SLIPPERY"]["staticFrictionCoefficient"] = 0.6*scale_1 surfaces["SLIPPERY"]["slidingFrictionCoefficient"] = 0.2*scale_2 be:setGroundModel("SLIPPERY", surfaces["SLIPPERY"])
end

local function reload()
reloadUI()
be:reloadVehicle(0)
end

M.ColorCycler2 = ColorCycler2
M.Drift_Drag_WTF_Mode = Drift_Drag_WTF_Mode
M.reload = reload
return M