angular.module('beamng.apps')
.directive('cheatPanel', [function () {
  return {
	templateUrl: '/ui/modules/apps/cheatPanel/app.html',
	replace: true,

  link: function (scope, element, attrs) {
	clearInterval(Time_Interval);
	clearInterval(Time_Interval_2);
	scope.ON_OFF_RAINBOW = false;
	scope.Roughness = 0.25;
	scope.ON_OFF_DRIFT = false
	scope.ON_OFF_DRAG = false
	scope.ON_OFF_WTF = false
	scope.ON_OFF_GM_ENGINE = false
	scope.ON_OFF_MORE_POWER = false
	scope.ON_OFF_MORE_POWER_AUTO = false
	var ON_OFF_AUTO = 0

	var Time_Interval = setInterval( () => {
		if (scope.ON_OFF_RAINBOW === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.ColorCycler2(' + scope.Roughness + ')')
		};
	}, 0);

	var Time_Interval_2 = setInterval( () => {
		//дрифт/драг/втф
		if (scope.ON_OFF_DRAG === false && scope.ON_OFF_DRIFT === false && scope.ON_OFF_WTF === false) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
		};

		if (scope.ON_OFF_DRIFT === true && scope.ON_OFF_DRAG === true && scope.ON_OFF_WTF === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
			scope.ON_OFF_DRIFT = false
			scope.ON_OFF_DRAG = false
			scope.ON_OFF_WTF = false
		};

		if (scope.ON_OFF_DRIFT === true && scope.ON_OFF_DRAG === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
			scope.ON_OFF_DRIFT = false
			scope.ON_OFF_DRAG = false
		};

		if (scope.ON_OFF_DRIFT === true && scope.ON_OFF_WTF === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
			scope.ON_OFF_DRIFT = false
			scope.ON_OFF_WTF = false
		};

		if (scope.ON_OFF_WTF === true && scope.ON_OFF_DRAG === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
			scope.ON_OFF_WTF = false
			scope.ON_OFF_DRAG = false
		};

		if (scope.ON_OFF_DRIFT === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 1 + ')')
		};

		if (scope.ON_OFF_DRAG === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 2 + ')')
		};

		if (scope.ON_OFF_WTF === true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 3 + ')')
			bngApi.activeObjectLua('extensions.cheatPanel.WTF_MODE()')
		};

		//моторная часть
		if (scope.ON_OFF_MORE_POWER_AUTO === false) {
			ON_OFF_AUTO = 0
		};

		if (scope.ON_OFF_MORE_POWER_AUTO === true) {
			ON_OFF_AUTO = 1
		};

		if (scope.ON_OFF_GM_ENGINE === false && scope.ON_OFF_MORE_POWER === true) {
			scope.ON_OFF_GM_ENGINE = true
		};

		if (scope.ON_OFF_GM_ENGINE === false) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_GM_ENGINE(' + 0 + ')')
		};

		if (scope.ON_OFF_GM_ENGINE === true) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_GM_ENGINE(' + 1 + ')')
		};

		if (scope.ON_OFF_MORE_POWER === false) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_MORE_POWER(' + 0 + ',' + ON_OFF_AUTO + ')')
		};

		if (scope.ON_OFF_MORE_POWER === true) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_MORE_POWER(' + 1 + ',' + ON_OFF_AUTO + ')')
		};

		//тест языка
		var lang = vueI18n.global.locale
		if (lang === 'ru_RU') {
			if (document.getElementById('Author').innerHTML !== 'By Ns Pro') {
				document.getElementById('ON_OFF_RAINBOW').innerHTML = 'Включение режима радуги';
				document.getElementById('Roughness').innerHTML = 'Шероховатость';
				document.getElementById('Roughness').style.fontSize='11px';
				document.getElementById('Roughness').style.marginTop ='2px'

				document.getElementById('ON_OFF_DRIFT').innerHTML = 'Включение дрифт режима';
				document.getElementById('ON_OFF_DRAG').innerHTML = 'Включение драг режима';
				document.getElementById('ON_OFF_WTF').innerHTML = 'Включение WTF режима';

				document.getElementById('ON_OFF_GM_ENGINE').innerHTML = 'Неразрушаемый двигатель';
				document.getElementById('Reload').innerHTML = 'Перезагрузка';
				document.getElementById('Reload').style.marginLeft = '211px';
				document.getElementById('Reload').style.marginTop = '-22px';
				document.getElementById('Reload').style.fontSize = '13px';
				document.getElementById('Reload_button').style.minWidth = '83px';
				document.getElementById('Reload_button').style.Width = '83px';
				document.getElementById('Reload_button').style.maxWidth = '83px';
				document.getElementById('Reload_button').style.marginLeft = '211px';
				document.getElementById('ON_OFF_MORE_POWER').innerHTML = 'БОЛЬШЕ МОЩИ!!!';
				document.getElementById('ON_OFF_MORE_POWER_AUTO').innerHTML = 'Авто';
				document.getElementById('Author').innerHTML = 'By Ns Pro';
			};
		};
	}, 1000);

	scope.Reload = function () {
		bngApi.engineLua('scripts_cheatPanel_extension.reload()')
	};

	scope.$on('$destroy', () => {
		scope.ON_OFF_RAINBOW = false;
		scope.Roughness = 0.25;
		scope.ON_OFF_DRIFT = false
		scope.ON_OFF_DRAG = false
		scope.ON_OFF_WTF = false
		scope.ON_OFF_GM_ENGINE = false
		scope.ON_OFF_MORE_POWER = false
		scope.ON_OFF_MORE_POWER_AUTO = false
		var ON_OFF_AUTO = 0
		clearInterval(Time_Interval)
		clearInterval(Time_Interval_2)
	});
	}
}}]);